program Set_06;
{
  .
   :
1) ,      
2) ,      
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';

type

  TSetOfChars = class(TSetList)
    procedure LoadFromString(arg : string);
  end;

////////////////////////////////////////////////////////////////

{ TSetOfChars }

procedure TSetOfChars.LoadFromString(arg: string);
var  i: integer;
begin
  Clear;
  for i := 1 to Length(arg) do
    if Ord(arg[i]) in [33..127]
      then Insert(TItemChar.Create(arg[i]));
end;

////////////////////////////////////////////////////////////////
//   

procedure Main1;
var F: Text;
    S: string;
    SetSum, SetExOr : TSetOfChars;
    St : TSetOfChars;

begin
  SetSum:= TSetOfChars.Create;
  SetExOr:= TSetOfChars.Create;
  St:= TSetOfChars.Create;

  Assign(F, 'Set06.dpr'); Reset(F);
  while not Eof(F) do begin
    Readln(F, S);
    St.LoadFromString(S);
    SetSum.Add(St);
    SetExOr.ExOr(St);
  end;
  SetSum.Sub(SetExOr);
  SetExOr.Expo;
  SetSum.Expo;
end;

////////////////////////////////////////////////////////////////
//   

type TCharSet = set of char;

procedure SetPrint(const arg : TCharSet);
var c : char;
begin
  for c in arg do Write(Output, c:2);
  Writeln(Output);
end;

procedure Main2;
var F: Text;
    S: string;
    SetSum, SetExOr : TCharSet;
    St:  TCharSet;
    i: integer;

begin
  SetSum:= [];  SetExOr:= [];
  Assign(F, 'Set06.dpr'); Reset(F);
  while not Eof(F) do begin
    Readln(F, S);
    St:=[];
    for i:= 1 to Length(S) do
      if Ord(S[i]) in [33..127] then St:= St + [ S[i] ];
    SetSum:= SetSum + St;
    SetExOr:= SetExOr + St - SetExOr*St;
  end;
  SetSum:= SetSum -  SetExOr;
  SetPrint(SetExOr);
  SetPrint(SetSum);
end;

////////////////////////////////////////////////////////////////

begin
  try
    Main1;  //   
    Writeln('---------------------------');
    Main2;  //   
    Writeln('---------------------------');
    Readln;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
