program Graph_15a;
//////////////////////////////////////////////////////////////
///      
///  (  )
///   -
//////////////////////////////////////////////////////////////

{$APPTYPE CONSOLE}

uses
  SysUtils, DateUtils,
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  Assembly in '..\Common\Assembly.pas',
  SetUtils in '..\Common\SetUtils.pas';

var   Gr : TGraphChars;
       S : string;
       P : TBuffer;
    Node1, Node2 : TNode;
    Start, Time : TDateTime;
    i, N1, N2 : integer;

begin
  Gr:= TGraphChars.Load('Test_1.txt');
  Gr.Expo;
  Writeln('- - - - - - - - - - - - - - - - - -');
  repeat
    Write('S:= '); Readln(S);  //     -  
    if Length(S)<2 then break; //  

    //  ,     :
    Node1:= Gr.GetNode(Upcase(S[1]));  //  
    Node2:= Gr.GetNode(Upcase(S[2]));  //  

    //     
    P:= Gr.GenDijkstra(Node1, Node2);
    if Assigned(P) then P.Expo;
    P.Free;
    Writeln('- - - - - - - - - - - - - - - - - -');

    //     ,
    //   -
    Writeln(Gr.GetQuickPathStr(Node1, Node2));
    Writeln('- - - - - - - - - - - - - - - - - -');

    //    

    Start:= Now;  N1:=0;
    repeat
      for i:=1 to 1000 do begin
        P:= Gr.GenDijkstra(Node1, Node2);    //  
        P.Free;
      end;
      Inc(N1);
      Time:= MilliSecondsBetween(Start, Now);
    until Time>1000;

    Start:= Now;  N2:=0;
    repeat
      for i:=1 to 1000 do begin
        P:= Gr.GenQuickPath(Node1, Node2);   //   
        P.Free;
      end;
      Inc(N2);
      Time:= MilliSecondsBetween(Start, Now);
    until Time>1000;
    //  
    Writeln('QuickPath / Dijkstra = ', N2/N1:5:2);

  until false;
  Gr.Free;
end.

