program Graph_21b;
{
  P-
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

var Gr: TGraphChars;
    PCenters: TCostSet;
    P : integer;
    Lambda : integer;
    Start, Time : TDateTime;
    D : char;
    Direct : TCenter;

begin
  try
//    Assign(Output,'Out-2.txt'); Rewrite(Output);
  //Gr:= TGraphChars.Load('Test_4d.txt');
  Gr:= TGraphChars.Load('Test_5.txt');
  //Gr:= TGraphChars.Load('Test_8d.txt');
  //Gr:= TGraphChars.GenRandom(false, 10, 10, 20, 50);
  Gr.Expo;
  Writeln('- - - - - - - - - - - - - - - - - -');
  Write('Direction (I/O/A) = '); Readln(D);
  case Upcase(D) of
    'I': Direct:= InCenter;
    'O': Direct:= OutCenter;
    else Direct:= InOutCenter;
  end;
  repeat
    Write('P= '); Readln(P);
    if P=0 then Break;
    case Direct of
      InCenter: Writeln('------------------- IN -------------------');
      OutCenter: Writeln('------------------- OUT -------------------');
      InOutCenter: Writeln('------------------- IN-OUT -------------------');
    end;
    Start:= Now;
    PCenters:= Gr.GenPCenters(P, Lambda, Direct);
    Time:= MilliSecondsBetween(Start, Now);
    if Assigned(PCenters) then begin
      Writeln('- - - - - - - - - - - - - - - - - -');
      PCenters.Expo;
      Writeln('Lambda= ', Lambda);
      Writeln('Time (ms) = ', Time:6:0);
      PCenters.ClrAndDestroy;
      PCenters.Free;
    end;
    ////////////////////////////////////////////////////
  until false;
//    Close(Output);
    Gr.Free; //  
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.

