program Graph_27a;
{
     ,  
}
{$APPTYPE CONSOLE}

uses
  SysUtils, DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

var
  Gr : TGraph;
  Res : TCostSet;   //  ()
  Start: TDateTime; //   
  Time : integer;
  Nodes : integer;  //  
  Retry : integer;  //  
  i : integer;
  Sum1, Sum2 : integer;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//  

procedure ResultExpo(const aFile: String);
var n: integer;
begin
  if aFile <> '' then begin
    Assign(Output, aFile);
    if FileExists(aFile)  then Append(Output)   else Rewrite(Output)
  end;
  Writeln('---------------------------------------------------');
  Writeln('Nodes=', Nodes:4, ' Retry=', Retry:4);
  Writeln('Flow= ', Sum1/Retry:7:1, ' ms');
  Writeln('Hung= ', Sum2/Retry:7:1, ' ms');
  Writeln('F/H = ', (Sum1+0.1)/(Sum2+0.1) :7:1);
  Writeln('---------------------------------------------------');
  if aFile <> '' then begin
    Close(Output);  Assign(Output, '');    Rewrite(Output);
  end;
end;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

begin
  try
  repeat
    Write('Nodes= '); Readln(Nodes);
    if Nodes<3 then Break;
    Write('Retry= '); Readln(Retry);
    if Retry=0 then Break;
    Sum1:= 0; Sum2:= 0;
    for i:= 1 to Retry do begin
      Gr:= THugeGraph.GenDicoty(99, Nodes);
      Write('.');
      //  :
      Start:= Now;
      Res:= Gr.GenMinPairsDicotyFlow;
      Time:= MilliSecondsBetween(Start, Now);
      Inc(Sum1, Time);
      Res.Free;
      // 
      Start:= Now;
      Res:= Gr.GenMinPairsDicoty;
      Time:= MilliSecondsBetween(Start, Now);
      Inc(Sum2, Time);
      Res.Free;
      Gr.Free;
    end;
    Writeln(#7);
    ResultExpo('');
//    ResultExpo('Out_17c.txt');
  until false;

  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
