program Graph_17b;
//////////////////////////////////////////////////////////////
//   (Clique)

{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas';

var Gr: TGraphChars;
    Clique: TSet;
    S : string;
    Start, Time : TDateTime;
    N: integer;

begin
  try
  //Assign(Output,'Out.txt'); Rewrite(Output);
  repeat
    Gr:= TGraphChars.Load('Page44.txt');
    //Gr:= TGraphChars.Load('Test_4.txt');
    //Gr:= TGraphChars.GenRandom(false, 1, 1, 20, 150);
    //Writeln('- - - - - - - - - - - - - - - - - -');
    Gr.Expo;
    Writeln('- - - - - - - - - - - - - - - - - -');
    Start:= Now;
    for N:= 1 to 1 do begin
      Clique:= Gr.GenClique;
      if N=1 then Clique.Expo;
      //  
      Clique.ClrAndDestroy;
      Clique.Free;
    end;
    Time:= MilliSecondsBetween(Start, Now);
    Writeln('- - Clique - -');
    Writeln('Time (ms) = ', Time:5:1);
    Readln(S);
    if S='s' then Gr.Save('Saved.txt');
    //  
    Gr.Free;
  until S<>'';
  //Close(Output);
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
