program Graph_28c;
{
    
}
{$APPTYPE CONSOLE}

uses
  SysUtils,  DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

var
  Gr : TGraph;
  Res : TCostSet;   //  ()
  Start: TDateTime; //   
  Time : integer;
  Nodes : integer;  //  
  Retry : integer;  //  
  i : integer;
  Sum1, Sum2 : integer;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//  

procedure ResultExpo(const aFile: String);
begin
  if aFile <> '' then begin
    Assign(Output, aFile);
    if FileExists(aFile)  then Append(Output)   else Rewrite(Output)
  end;
  Writeln('---------------------------------------------------');
  Writeln('Nodes=', Nodes:4, ' Retry=', Retry:4);
  Writeln('Max= ', Sum1/Retry:7:1,  ' ms');
  Writeln('Opt= ', Sum2/2/Retry:7:1,' ms');
  Writeln('---------------------------------------------------');
  if aFile <> '' then begin
    Close(Output);  Assign(Output, '');    Rewrite(Output);
  end;
end;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

begin
  try
  repeat
    Write('Nodes= '); Readln(Nodes);
    if Abs(Nodes)<3 then Break;
    Write('Retry= '); Readln(Retry);
    if Retry=0 then Break;
    Sum1:= 0; Sum2:= 0;
    for i:= 1 to Retry do begin
      // 
//      Gr:= TGraphChars.GenFull((Nodes>0), 0, 99, Abs(Nodes));
      // 
//      Gr:= THugeGraph.GenDicoty(99, Nodes);
      // 
      Gr:= TGraphChars.GenRandom(false, 0, 99, Nodes, {%= } -20);
      // 
//      Gr:= TGraphChars.GenRandom(true, 0, 99, Nodes, {%= } -20);
//Gr.Expo;
      Write('.');
      //    :
      Start:= Now;
      Res:= Gr.GenPairs_Dissect(pMaxN);
      Time:= MilliSecondsBetween(Start, Now);
      Inc(Sum1, Time);
      Res.Free;
      //  
      Start:= Now;
      Res:= Gr.GenPairs_Dissect(pMinW);
      Time:= MilliSecondsBetween(Start, Now);
      Inc(Sum2, Time);
      Res.Free;
      //  
      Start:= Now;
      Res:= Gr.GenPairs_Dissect(pMaxW);
      Time:= MilliSecondsBetween(Start, Now);
      Inc(Sum2, Time);
      Res.Free;
      Gr.Free;
    end;
    Writeln(#7);   ResultExpo('');
    ResultExpo('Out_17d.txt');
  until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
