program Graph_35_travel;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';

var Gr : TGraph;
    Res: TBuffer;
    Cost: integer;
    Nodes: integer;
    Na, Nb : TNode;

begin
  try
  repeat
    Gr:= nil;
    Write(#10#10'Nodes= '); Readln(Nodes);
    if Nodes < 4 then Break;
//    Gr:= TGraphChars.Load('Test-8.txt');
    Gr:= TGraphChars.Load('Test-8d.txt');
//    Gr:= TGraphChars.Load('Test-5d.txt');
    Gr.Expo;
    ///----- Cycle

    Writeln('- - - - - - - - - - - - - -');
    Writeln('         Cycle');
    Res:= Gr.GenTravelCycle(Cost);
    Res.Expo;
    Writeln('Cost= ',Cost);
    Res.Free;
    Writeln('- - - - - - - - - - - - - -');

    ///----- Path
    Writeln('- - - - - - - - - - - - - -');
    Writeln('         Path');
    Na:= (Gr as TGraphChars).GetNode('A');
    Nb:= (Gr as TGraphChars).GetNode('B');
    Res:= Gr.GenTravelPath(Na, Nb, Cost);
    Res.Expo;
    Writeln('Cost= ',Cost);
    Res.Free;
    Writeln('- - - - - - - - - - - - - -');
    Gr.Free;
  until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
